#include <iostream>

using namespace std;


void displayBits(unsigned char *ptr, int numberOfBytes)
{
   
   for(int i=0; i<numberOfBytes; i++)
     {
	unsigned char displayMask = 1 << 7;
	for(int c = 1; c <=8; c++)
	  {
	     std::cout << (ptr[i] & displayMask ? '1' : '0') ;
	     ptr[i] <<= 1;
	     if( c%8 == 0)
	       std::cout << ' ';
	  }
     }
   
   std::cout << std::endl;

}

#include "util.h"

int main()
{
   //int size = 100;
   float x=0.5;
   float y=0.5;
   float z=0.5;

   int exitstatus = 0;

//   displayBits( (unsigned char *)&x , sizeof(x) );
//   displayBits( (unsigned char *)&y , sizeof(y) );
//   displayBits( (unsigned char *)&z , sizeof(z) );


//--------------------------------------------------
// Parent
   
   for(int i=0;i<64;i++)
      cout << "Parent of " << i <<  " is: " << Parent(i) << endl;

//--------------------------------------------------
// Children
   for(int i=0;i<64;i++)
   {
      int child[8];
      cout << "Children of " << i <<  " are: ";
      ChildrenAll(i,child);
      for(int j=0;j<8;j++)
	 cout << child[j] << " ";
      cout << "\n";
   }

//--------------------------------------------------
// exponent

   for(float i=0;i<10.0;i+=.1)
   {
      cout << "exponent of " << i <<  " is: " << exponent(i) << endl;
   }
   
   cout << "exponent of " << x <<  " is: " << exponent(x) << endl;
   cout << "exponent of " << y <<  " is: " << exponent(y) << endl;
   cout << "exponent of " << z <<  " is: " << exponent(z) << endl;
   float q = 0.000502785;
   cout << "exponent of " << q <<  " is: " << exponent(q) << endl;


//--------------------------------------------------
// mantissa
   for(float i=0;i<10.0;i+=.1)
   {
      cout << "mantissa of " << i <<  " is: " << mantissa(i) << endl;
   }

   cout << "mantissa of " << x <<  " is: " << mantissa(x) << endl;
   cout << "mantissa of " << y <<  " is: " << mantissa(y) << endl;
   cout << "mantissa of " << z <<  " is: " << mantissa(z) << endl;

//--------------------------------------------------
// Deinterleave

   int i,j,k;
   int level = 2;
   int box = 8;
   Deinterleave(box,level,&i,&j,&k);
   cout << "Deinterleave of " << box << " is: ";
   cout << i << " " << j << " " << k << endl;

//--------------------------------------------------
// Interleave


//--------------------------------------------------
// Deinterleave and Interleave

   // interleave and deinterleave should be inverses of each other
   level = 3;
   for(int i=0;i<100;i++)
   {
      int x,y,z;
      box = i;
      Deinterleave(box,level,&x,&y,&z);
      int t = Interleave(x,y,z,level);
      std::cout << "box: " << box << " result: " << t << std::endl;
   }
//--------------------------------------------------
// Deinterleave and Interleave

   // interleave and deinterleave should be inverses of each other
   level = 3;
   for(int i=0;i<5;i++)
      for(int j=0;j<5;j++)
	 for(int k=0;k<5;k++)
	 {
	    int x=i,y=j,z=k;
	    std::cout << "before interleave-deinterleave: " 
		      << x << " " << y << " " << z << "\n";
	    int t = Interleave(x,y,z,level);
	    Deinterleave(t,level,&x,&y,&z);
	    std::cout << "after interleave-deinterleave:  " 
		      << x << " " << y << " " << z << "\n";
	 }

//--------------------------------------------------
// Box
   level = 2;
   for(float x=0;x<1;x+=.25)
      for(float y=0;y<1;y+=.25)
	 for(float z=0;z<1;z+=.25)
	 {
	    int tmp = Box(x,y,z,level);
	    cout << "Box index of " << x << " " << y << " " << z << " is " 
		 << tmp << endl;
	 }
   x=0.126987;y= 0.0040902;z= 0.000502785;
   int tmp = Box(x,y,z,level);
   cout << "Box index of " << x << " " << y << " " << z << " is " 
	<< tmp << endl;
//--------------------------------------------------
// Center

   level = 2;
   float center[3];
   for(int j=0;j<64;j++)
   {
      box = j;
      Center(box,level,center);
      cout << "Center of box " << box << " at level " << level << " is "
	   << center[0] << " " << center[1] << " " << center[2] << endl;
   }

//--------------------------------------------------
// Nearest Neighbors
   
   for(int j=0;j<64;j++)
   {
      box = j;
      level = 2;
      int neighbors[27];
      int n = NearestNeighbors(box,level,neighbors);
      cout << "Neighbors of box " << box << " are: ";
      for(int i=0;i<n;i++)
	 cout << neighbors[i] << " ";
      cout << endl;
   }
//--------------------------------------------------
// Interaction List
   for(int j=0;j<64;j++)
   {
      box = j;
      level = 2;
      int neighbors[189];
      int n = InteractionList(box,level,neighbors);
      cout << "InteractionList of box " << box << " with size " << n << " is: ";
      for(int i=0;i<n;i++)
	 cout << neighbors[i] << " ";
      cout << endl;
   }






   return exitstatus;
   
}




int main2()
{

   std::cout.setf(std::ios_base::scientific,std::ios_base::floatfield);
   std::cout.precision(8);

   int size = 100;
   float x=0.0;
   for(int i=0;i<size;i++)
     { 
	x += 1.0/size;
	float y=x;
	displayBits( (unsigned char *)&y , sizeof(x) );
	cout << "exponent of " << x <<  " is: " << exponent(x) <<endl;
	cout << "mantissa of " << x <<  " is: " << mantissa(x) <<endl;
     }
//   x = .1;
//   cout << x <<  ": " << exponent(x) <<endl;
//   cout << x <<  ": " << mantissa(x) <<endl;
   
//   cout << hex << Interleave(.543,.232,.839,5) <<endl;
   
//   if(0.999999999999999999999999 == 1.0)
//      cout << "Equal" << endl;
}

